//
//  GSLayer+MetricsKeysUI.h
//  GlyphsCore
//
//  Created by Georg Seifert on 31.08.15.
//  Copyright (c) 2015 schriftgestaltung.de. All rights reserved.
//

#import <GlyphsCore/GSLayer.h>

/**
 States of metrics keys
 */

typedef NS_OPTIONS(uint8_t, GSMetricsKeysUI) {
	GSMetricsKeysOK = 0,
	GSMetricsKeysOutOfSync = 1 << 0,
	GSMetricsKeysInvalid = 1 << 1,
	GSMetricsKeysPlaceholder = 1 << 2,
};

@interface GSLayer (MetricsKeysUI)

+ (NSInteger)alignedMetricsValueForKey:(NSString *)key;

- (BOOL)metricsKeysOutOfSync;

- (NSString *)plainMetricsKeyUI:(GSMetricNumbers)side;

@property (nonatomic, unsafe_unretained, nullable) NSString *leftMetricsKeyUI;
- (GSMetricsKeysUI)leftMetricsKeyState;
- (NSString *)leftMetricsKeyState:(GSMetricsKeysUI *__nullable)state;
- (NSString *)leftPlainMetricsKey;

@property (nonatomic, unsafe_unretained, nullable) NSString *widthMetricsKeyUI;
- (NSString *__nonnull)widthMetricsKeyUIFast;
- (GSMetricsKeysUI)widthMetricsKeyState;
- (NSString *__nonnull)widthMetricsKeyState:(GSMetricsKeysUI *__nullable)state;
- (NSString *)widthPlainMetricsKey;

@property (nonatomic, unsafe_unretained, nullable) NSString *rightMetricsKeyUI;
- (GSMetricsKeysUI)rightMetricsKeyState;
- (NSString *__nonnull)rightMetricsKeyState:(GSMetricsKeysUI *__nullable)state;
- (NSString *)rightPlainMetricsKey;

@property (nonatomic, unsafe_unretained, nullable) NSString *topMetricsKeyUI;
- (GSMetricsKeysUI)topMetricsKeyState;
- (NSString *__nonnull)topMetricsKeyState:(GSMetricsKeysUI *__nullable)state;
- (NSString *)topPlainMetricsKey;

@property (nonatomic, unsafe_unretained, nullable) NSString *bottomMetricsKeyUI;
- (GSMetricsKeysUI)bottomMetricsKeyState;
- (NSString *__nonnull)bottomMetricsKeyState:(GSMetricsKeysUI *__nullable)state;
- (NSString *)bottomPlainMetricsKey;

- (CGFloat)vertWidthUI;

@property (nonatomic, unsafe_unretained, nullable) NSString *vertOriginKeyUI;
- (NSString *__nonnull)vertOriginMetricsKeyState:(GSMetricsKeysUI *__nullable)state;

@property (nonatomic, unsafe_unretained, nullable) NSString *vertWidthMetricsKeyUI;
- (GSMetricsKeysUI)vertWidthMetricsKeyState;
- (NSString *__nonnull)vertWidthMetricsKeyState:(GSMetricsKeysUI *__nullable)state;
- (NSString *)vertWidthPlainMetricsKey;

+ (NSColor *)colorForMetricsState:(GSMetricsKeysUI)state;
@end
